<?php

/**
 * @file
 * Contains \Drupal\panels\getCachedValuesTrait.
 */

namespace Drupal\panels;

use Drupal\user\SharedTempStoreFactory;

trait CachedValuesGetterTrait {

  protected function getCachedValues(SharedTempStoreFactory $tempstore, $tempstore_id, $machine_name) {
    $cached_values = $tempstore->get($tempstore_id)->get($machine_name);

    $machine_name = explode('--', $machine_name);
    // PageManager specific handling. If $machine_name[1] is set, it's the
    // page variant ID.
    if (isset($machine_name[1]) && !isset($cached_values['page_variant'])) {
      /** @var \Drupal\page_manager\PageInterface $page */
      $page = $cached_values['page'];
      $cached_values['page_variant'] = $page->getVariant($machine_name[1]);
    }
    if (!isset($cached_values['plugin']) && !empty($cached_values['page_variant'])) {
      $cached_values['plugin'] = $cached_values['page_variant']->getVariantPlugin();
    }
    return $cached_values;
  }

}
