<?php

/**
 * @file
 * Contains \Drupal\panels\Plugin\PanelsPattern\PanelsPatternInterface.
 */

namespace Drupal\panels\Plugin\PanelsPattern;

use Drupal\Component\Plugin\PluginInspectionInterface;
use Drupal\user\SharedTempStoreFactory;

interface PanelsPatternInterface extends PluginInspectionInterface {

  /**
   * @param array $cached_values
   *
   * @return mixed
   */
  public function getMachineName(array $cached_values);

  /**
   * @param \Drupal\user\SharedTempStoreFactory $tempstore
   * @param string $tempstore_id
   * @param string $machine_name
   *
   * @return \Drupal\Core\Plugin\Context\ContextInterface[]
   */
  public function getDefaultContexts(SharedTempStoreFactory $tempstore, $tempstore_id, $machine_name);

  /**
   * @param string $tempstore_id
   * @param string $machine_name
   * @param string $region
   * @param string $destination
   *
   * @return \Drupal\Core\Url
   */
  public function getBlockListUrl($tempstore_id, $machine_name, $region = NULL, $destination = NULL);

  /**
   * @param string $tempstore_id
   * @param string $machine_name
   * @param string $block_id
   * @param string $region
   * @param string $destination
   *
   * @return \Drupal\Core\Url
   */
  public function getBlockAddUrl($tempstore_id, $machine_name, $block_id, $region = NULL, $destination = NULL);

  /**
   * @param string $tempstore_id
   * @param string $machine_name
   * @param string $block_id
   * @param string $destination
   *
   * @return \Drupal\Core\Url
   */
  public function getBlockEditUrl($tempstore_id, $machine_name, $block_id, $destination = NULL);

  /**
   * @param string $tempstore_id
   * @param string $machine_name
   * @param string $block_id
   * @param string $destination
   *
   * @return \Drupal\Core\Url
   */
  public function getBlockDeleteUrl($tempstore_id, $machine_name, $block_id, $destination = NULL);

}
